/*===========================================================================
                            .
===========================================================================*/
unsigned char ColSimb = 0;
unsigned char ColStolb = 0;
//unsigned char ColStolb_1 = 0;
unsigned char cnt_Page = 0;         //  .
unsigned char Ind_1;
//unsigned char Del_1 = 1;   // 2;         // mks
//unsigned char Del_2 = 1;         // ms
//unsigned char Del_3 = 50;         // ms
//unsigned char Del_P = 300;         // mks
//unsigned char Del_NOP = 2; //5;         // mks
//unsigned char cnt_col = 0;
unsigned char c1,c2,c3;
unsigned char d2,d3;
//---------------------------------------------------------------------------
void reset_Displ(void);
void clr_Scr(void);
void set_Page();
void set_Colon();
void Indicator();
void write_Bit();
void write_Simb();
void write_Simb_HI();
void Write_Screen();
//void Indic_HI();
void Tab_Simb_8_x_8_Rus();
//void Inverse_Simbol_Time();
//void Inverse_Simbol_HI();
void Select_Cristall();
void ramka_Scr();
//void Analog_Signal();
/*===========================================================================
                                .
===========================================================================*/
void write_Bit()
{
   output_low(PIN_D4);         // E<-0
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(1);
   delay_us(1);
   output_high(PIN_D6);      // A<-1, write screen.
   delay_us(1);
   output_high(PIN_D4);      // E<-1, enable wr.screen.
   delay_us(1);
   delay_us(1);
   output_low(PIN_D4);         // E<-0
   delay_us(1);
   output_low(PIN_D4);         // set Stolb
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(1);
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void Indicator()
{
   bit_mask = 1;
   for (c=0; c<8; c++)
   {
   output_low(PIN_C6);         //  Dat.
   if (Ind_1 & bit_mask)
   output_high(PIN_C6);      //  Dat.
   else output_low(PIN_C6);   //  Dat.
   output_high(PIN_C7);      //   CLK.
   delay_us(2);            //  10 k.
   output_low(PIN_C7);         //   CLK.
   bit_mask <<=1;            //      
   }                     //  .
   output_low(PIN_C6);         //   Dat.
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void set_Colon()
{
   bit_set(Ind_1, 6);         // set Colonky 40(stolbec).
   Indicator();            //    .
   delay_us(1);
   output_high(PIN_D4);      // E<-1, enable write.
   delay_us(1);
   output_low(PIN_D4);         // E<-0
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(1);
   return;
}
/*===========================================================================
                            .
===========================================================================/
void Inverse_Simbol_Time()
{
   if (Inverse_Time == 1)
   {
      if (Select_Const == 4)
      {
      if (ColSimb == 8)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      if (ColSimb == 7)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      }
      if (Select_Const == 5)
      {
      if (ColSimb == 5)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      if (ColSimb == 4)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      }
      if (Select_Const == 6)
      {
      if (ColSimb == 2)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      if (ColSimb == 1)
      Out_Dat = Out_Dat ^ 0xFF;   //   .
      }
   }
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void write_Simb()
{
   while (ColStolb_1 < 8)
   {
   Ind_1 = ColStolb;
   Indicator();            //    .
   set_Colon();            //  .
   Tab_Simb_8_x_8();
 //  if (Inverse_Time == 1) Inverse_Simbol_Time();
   Ind_1 = Out_Dat;
   Indicator();            //    .
   write_Bit();
   ColStolb_1++;
   ColStolb--;
   }
   ColStolb_1 = 0;
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void set_Page()
{
   Ind_1 = Ind_1 + 0b10111000;   //  .
   Indicator();            //    .
   delay_us(1);
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(1);
   output_high(PIN_D4);      // E<-1, enable set
   delay_us(1);
   output_low(PIN_D4);         // E<-0
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(1);
   return;
}
/*===========================================================================
                            .
===========================================================================*/
void Select_Cristall()
{
   output_high(PIN_C5);      //    .
   output_low(PIN_C4);
   ColStolb = 0x3F;
   cnt_Page = 5;
   Ind_1 = 5;               //   5.
   Indicator();            //    .
   set_Page();               //  .
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void reset_Displ(void)
{
   output_high(PIN_C4);      // E1<-1
   output_high(PIN_C5);      // E2<-1
   delay_us(1);
   output_low(PIN_D3);         // impuls Reset.
   delay_us(1);
   output_high(PIN_D3);      // end impuls.
   delay_us(1);
/*---------------------------------------------------------------------------
                         .
---------------------------------------------------------------------------*/
   output_low(PIN_D4);         // E<-0,A0<-0, rd/wr<-0
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_us(2);
   Ind_1 = 0b00111111;         // data Display <- ON.
   Indicator();            //    .
   delay_us(1);
   output_high(PIN_D4);      // E<-1, enable write.
   delay_us(1);
   output_low(PIN_D4);         // E<-0, end write.
   output_low(PIN_D5);
   output_low(PIN_D6);
   Ind_1 = 0;
   Indicator();            //    .
   delay_ms(1);
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void clr_Scr(void)
{
//unsigned char c1,c2,c3;
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
/*-------------------------------------------------------------------------*/
   output_high(PIN_C4);      //   2. E2<-0.
   delay_us(2);
   output_low(PIN_C5);         //   1. E1<-1, 1 crystal.
   delay_us(2);
/*-------------------------------------------------------------------------*/
   for (c1=2; c1>0; c1--)      //   .
   {
      for (c2=8; c2>0; c2--)   //   .
      {
      Ind_1 = c2 - 1;         //  .
      set_Page();
         for (c3=0x40; c3>0 ;c3--)   //   .
         {
         Ind_1 = c3;         //  .
         set_Colon();
         Ind_1 = 0;         //  =0(). data<-0
         Indicator();      //    .
         write_Bit();      //  .
         }
      }
      output_high(PIN_C5);   //   1. E1=1, E1<-0.
      output_low(PIN_C4);      //   2. E2<-1, 2 crystal ON
   }
   output_high(PIN_C4);      //   2. E1<-1, screen ON
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_ms(50);
   return;
}
/*===========================================================================
                         .
===========================================================================*/
void Write_Screen()
{
   Indicator();               //    .
   set_Page();               //  .
   while (ColSimb > 0)
   {
   Digit[0] = Digit[ColSimb];
   write_Simb();
   ColSimb--;
   }
   delay_us(300);
   delay_us(300);
   return;
}
/*===========================================================================
                                .
===========================================================================*/
void Analog_Signal(void)
{
//unsigned char c1,c2,c3;
//unsigned char d2,d3;
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
/*-------------------------------------------------------------------------*/
   output_high(PIN_C4);            //   2. E2<-0.
   delay_us(2);
   output_low(PIN_C5);         //   1. E1<-1, 1 crystal.
   delay_us(2);
/*-------------------------------------------------------------------------*/
   for (c1=2; c1>0; c1--)      //   .
   {
   c2 = 2;
   Ind_1 = c2;            //  .
   set_Page();
   if (c1 == 2) d3 = 0x38;
   if (c1 == 2) d2 = 0x00;
   if (c1 == 1) d3 = 0x3F;
   if (c1 == 1) d2 = 0x06;
   for (c3=d3; c3>d2 ;c3--)   //   .
      {
      Ind_1 = c3;         //  .
      set_Colon();
      Ind_1 = 0x07;         //  =0(). data<-0
      if (Cristal[0] == c1)
         {
         if (Temp[1] == c3 - 1)   Ind_1 = 0xF7;
         if (Temp[1] == c3)       Ind_1 = 0xFF;
         if (Temp[1] == c3 + 1)   Ind_1 = 0xF7;
         }
      Indicator();         //    .
      write_Bit();         //  .
      }
      output_high(PIN_C5);      //   1. E1=1, E1<-0.
      output_low(PIN_C4);      //   2. E2<-1, 2 crystal ON
   }
   output_high(PIN_C4);         //   2. E1<-1, screen ON
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_ms(50);
   return;
}
/*===========================================================================
                                  .
===========================================================================*/
void ramka_Scr()
{
//unsigned char c1,c2,c3;
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
/*-------------------------------------------------------------------------*/
   output_high(PIN_C4);      //   2. E2<-0.
   delay_us(2);
   output_low(PIN_C5);         //   1. E1<-1, 1 crystal.
   delay_us(2);
/*-------------------------------------------------------------------------*/
   for (c1=2; c1>0; c1--)      //   .
   {
      for (c2=8; c2>0; c2--)   //   .
      {
      Ind_1 = c2 - 1;         //  .
      set_Page();
         for (c3=0x40; c3>0 ;c3--)   //   .
         {
         Ind_1 = c3;         //  .
         set_Colon();
         Ind_1 = 0;         //  =0(). data<-0
        
         if (c2 == 0x08) Ind_1 = 0x80;
         if (c2 == 0x01) Ind_1 = 0x01;
         if (c1 == 2)
         {
         if (c3 == 0x3F) Ind_1 = 0xFF;
         }
         if (c1 == 1)
         {
         if (c3 == 0x40) Ind_1 = 0xFF;
         }
         
         Indicator();      //    .
         write_Bit();      //  .
         }
      }
      output_high(PIN_C5);   //   1. E1=1, E1<-0.
      output_low(PIN_C4);      //   2. E2<-1, 2 crystal ON
   }
   output_high(PIN_C4);      //   2. E1<-1, screen ON
   output_low(PIN_D4);
   output_low(PIN_D5);
   output_low(PIN_D6);
   delay_ms(50);
   return;
}
/*=========================================================================*/
